Description

Here are some requirements:

Immediate requirements:

1. Ability to display a particular verse

2. Ability to display a particular chapter

3. An outline of the book (section and sub-sections)

4. Verse and chapters must be ordered

5. Chapters need a name (the first chapter may be a preface or introduction, not "chapter one")

6. Footnote support

Future requirements:

1. Morphological parsing of individual words

2. Ability to search contents

History

#1 - 08/31/2012 10:14 PM - Luke Murphey

- Description updated

#2 - 09/01/2012 07:33 AM - Luke Murphey

There are a few ways to handle this:

Use SGML/XML: this provides formatting and the XML structure would allow morphological parsing data to be included. Searching doesn't really

work unless using an XML database.

Use database model of chapter » verse » word: no formatting allowed but allows easy morphological parsing and seraching.

#3 - 09/10/2012 08:27 PM - Luke Murphey

- Status changed from New to In Progress

#4 - 09/13/2012 04:58 AM - Luke Murphey

May want to redo the model such that the verses and chapters use a foreign key relation. This is necessary to make deletions of the work cascade to

the verses and chapters.

See http://stackoverflow.com/questions/3937194/django-cascade-deletion-in-manytomanyrelation

#5 - 09/13/2012 05:48 AM - Luke Murphey

I could use something like markdown in order to process the text to handle formatting, footnotes and even lemmatization. See 

https://github.com/trentm/python-markdown2#readme
http://en.wikipedia.org/wiki/XML_database
http://stackoverflow.com/questions/3937194/django-cascade-deletion-in-manytomanyrelation
https://github.com/trentm/python-markdown2#readme


#6 - 09/13/2012 06:34 AM - Luke Murphey

I switched the models to use foreign keys so that the deletes cascade.

#7 - 10/02/2012 01:44 AM - Luke Murphey

I am refactoring the models such that Section and Chapter models are replaced a single model that does both: Division.

#8 - 10/02/2012 05:56 AM - Luke Murphey

The problem with the model that has verses foreign key to divisions is that it is difficult to find the lowest level of divisions. The lowest level of divisions

are the ones that need to be used for chunking.

It may be necessary to have verses be a many-to-many field within Division objects. However, this means that verses will not be deleted when

divisions are deleted.

#9 - 10/16/2012 06:09 PM - Luke Murphey

- Status changed from In Progress to Closed

- % Done changed from 0 to 100

This is now basically done. The model will be updated as necessary to support new functionality.
